package com.jbo.vga.didacticunit

import com.jbo.vga.model.Page
import java.io.File

class DidacticUnitContract {

    interface PresenterInterface {
        fun synchronizeResources(level: String, didacticUnitNumber: Int, cacheDirectory: File)
        fun loadDidacticUnit(level: String, didacticUnitNumber: Int)
        fun didacticUnitReady(cacheDirectory: File, level:String, didacticUnit: String): Boolean
        fun stop()
    }

    interface ViewInterface {
        fun openDidacticUnit(pages: List<Page>)
        fun showProgress()
        fun hideProgress()
        fun didacticUnitSynchronizationResult(synchronized: Boolean)
        fun displayError(message: String)
    }

}